#!/usr/bin/python3.6
# -*- coding: utf-8 -*-

import warnings

warnings.filterwarnings('ignore')


class DefaultConfig(object):
    """data"""
    data_type = "CUB"
    num_classes = 200

    #########################
    """model"""
    model_type = "BSCP"         # BSCP or BSCP_kernel

    #########################

    """optimizer"""
    optim = "sgd"                           # sgd/adam/  自定义: custom
    weight_decay = 5e-4
    momentum = 0.9

    """scheduler"""
    scheduler = 'MultiStepLR'                    # StepLR/OneCycleLR/MultiStepLR   自定义: custom
    max_lr = 0.1                                    # OneCycleLR
    step = 10                                       # StepLR
    gamma = 0.1                                     # StepLR/MultiStepLR
    milestones = [30, 40, 50, 60]                               # MultiStepLR

    """train"""
    lr = 0.01
    batch_size = 32
    epoch = 100
    k = 5                                   # top{k}

    """other config"""
    train = True                            # train
    fine_tune = False                       # fine tune

    frozen_params = False                    # train 冻结参数
    init_params = False                     # train 初始化参数

    plot_data = False                       # train/fine tune 数据集可视化
    plot_confMatrix = False                 # train/fine tune  混淆矩阵可视化

    send_message = False                     # train/fine tune
    save_weight = True                      # train/fine tune     仅保存模型参数
    save_model = False                      # train/fine tune     保存模型
    tensorboard = True                     # train/fine tune     tensorboard可视化

    """visualization"""
    plot_result = False                      # 模型的预测能力
    plot_kernel_feature = False              # kernel feature
    plot_feature_map = False                 # feature map
    attention = False

    """"""
    # load_weight = "weights/download_weight/vit_base_patch16_224_in21k.pth"  # train 加载模型的参数地址
    load_weight = ""            # train 加载模型的参数地址

    save_weight_path = "weights/train_weight"                                 # train/fine tune
    save_result = "runs/result"                                               # train/fine tune 保存结果的地址
    save_tensorboard = "runs/tensorboard"                                     # train/fine tune 保存tensorboard可视化的地址

    device = 'cuda:1'
    remark = ''                        # any remark


opt = DefaultConfig()

