
import torch
import argparse
""""""


def create_optimizer(args, model, op=None):

    optim = args.optim.lower()

    if op is None:
        parameters = model.parameters()
    else:
        parameters = op

    if optim == 'sgd':
        optimizer = torch.optim.SGD(parameters, lr=args.lr, momentum=args.momentum, weight_decay=args.weight_decay)
    elif optim == 'adam':
        optimizer = torch.optim.Adam(parameters, lr=args.lr, weight_decay=args.weight_decay)
    elif optim == 'adamw':
        optimizer = torch.optim.AdamW(parameters, lr=args.lr, weight_decay=args.weight_decay)
    elif optim == 'nadam':
        optimizer = torch.optim.NAdam(parameters, lr=args.lr, weight_decay=args.weight_decay)
    elif optim == 'asgd':
        optimizer = torch.optim.ASGD(parameters, lr=args.lr, weight_decay=args.weight_decay)
    elif optim == 'adagrad':
        optimizer = torch.optim.Adagrad(parameters, lr=args.lr, weight_decay=args.weight_decay)
    elif optim == 'radam':
        optimizer = torch.optim.RAdam(parameters, lr=args.lr, weight_decay=args.weight_decay)
    elif optim == 'adadelta':
        optimizer = torch.optim.Adadelta(parameters, lr=args.lr, weight_decay=args.weight_decay)
    elif optim == 'rmsprop':
        optimizer = torch.optim.RMSprop(parameters, lr=args.lr, weight_decay=args.weight_decay)
    elif optim == 'custom':             # todo
        optimizer = None
    else:
        optimizer = None
        assert False and "Invalid optimizer"

    return optimizer


if __name__ == "__main__":
    parser = argparse.ArgumentParser()
    parser.add_argument('--optim', default='aDaM')
    parser.add_argument('--lr', default=0.01)
    parser.add_argument('--weight_decay', default=5e-4)
    parser.add_argument('--momentum', default=0.09)
    args = parser.parse_args()
    model = torch.nn.Linear(3, 32)
    print(create_optimizer(args, model))

