# Requirements
·python 3.8
·pytorch 

# Prerequisites
Software and Hardware Requirements
You should first install some necessary packages.

Command:

Install Python >= 3.6
Install PyTorch >= 1.12
Install torchvision>=0.13.0

# Step1
Download the CUB-200-2011 dataset、Cras-196 dataset、Indoor dataset.
The format of the dataset is presented as:

|--CUB_200_2011
    |--datasets
        |--train
            |--001.Black_footed_Albatross
            |--002.Laysan_Albatross
            |--.....
        |-- test
            |--001.Black_footed_Albatross
            |--002.Laysan_Albatross
            |--.....
|--cars196
    |--...
```
Then, please configure the pathes of datasets in datasets.py
# step2

###############################
 1、Rk-FBP
run main.py in document BSCP_01

python main.py --model_type='BSCP' --l1=512 --l2=512 --p=512 --rank=2 --remark='l1=l2=512_P=512_rank=2'
python main.py --model_type='BSCP' --l1=300 --l2=300 --p=512 --rank=4 --remark='l1=l2=512_P=512_rank=2'




##############################
 2、multi-linear case
run main.py in BSCP_01

python main.py --model_type='BSCP_kernel' --use=2 --U 512 512 512 --V 512 512 512 --P 512 512 512 --RANK 2 2 2 --remark='RANK=[2,2,2]'

--use=2，generate second-order and third order features, and concatenate them into a vector.
--use=3，generate 2-th, 3-th, and 4-th order features, and concatenate them into a vector

##############################
 3、Employ the pruning strategy to learn sparse $P$ in the projection $y=P^Tvec(U^T(I_k \otimes X)V)$
 run main.py in prune_01
command:
python main.py --out_channel=512 --out_dim=512 --rank=2 --prune_start_epoch=1 --prune_iter_epoch=1 --amount=1000000 --remark='l1=l2=512_P=512_rank=2'
```
```java
--out_channel:dimension of U and V
--out_dim: dimension of P
--rank: k of I_k
--prune_start_epoch: 1
--prune_iter_epoch: 1
--amount:the number of elements in each pruning iteration
```
# Result
















